- name: Update packages
  apt:
    name: "*"
    state: latest
    update_cache: yes

- name: Install pre-requisites
  apt:
    name: "{{ item }}"
    state: latest
  loop:
    - gpg

- name: Trust K8s repo key
  apt_key:
    url: https://packages.cloud.google.com/apt/doc/apt-key.gpg
    state: present
    keyring: /usr/share/keyrings/kubernetes-archive-keyring.gpg

- name: Kubernetes repo
  apt_repository:
    repo: deb [signed-by=/usr/share/keyrings/kubernetes-archive-keyring.gpg] https://apt.kubernetes.io/ kubernetes-xenial main
    state: present
    filename: kubernetes

- name: Trust Docker repo key
  apt_key:
    url: https://download.docker.com/linux/debian/gpg
    state: present
    keyring: /usr/share/keyrings/docker-archive-keyring.gpg

- name: Docker repo
  apt_repository:
    repo: deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/debian bullseye stable
    state: present
    filename: docker

- name: install docker
  apt:
    name: "{{ item }}"
    state: latest
    update_cache: yes
  loop:
    - docker-ce
    - docker-ce-cli
    - containerd.io
  notify:
    - Ensure Docker is restarted

- name: install KKK
  apt:
    name: "{{ packages }}"
    state: latest
    update_cache: yes
  vars:
    packages:
    - kubectl
    - kubelet
    - kubeadm

- name: copy whatever this is
  copy:
    src: etc/sysctl.d/k8s.conf
    dest: /etc/sysctl.d/k8s.conf

- name: copy whtever this other thing is
  copy:
    src: etc/modules-load.d/k8s.conf
    dest: /etc/modules-load.d/k8s.conf

- name: Copy over Docker config (switch cgroup driver from cgroupfs to systemd)
  copy:
    src: etc/docker/daemon.json
    dest: /etc/docker/daemon.json
  notify:
    - Ensure Docker is restarted

- name: Disable SWAP since kubernetes can't work with swap enabled (1/2)
  shell: |
    swapoff -a

- name: Disable SWAP in fstab since kubernetes can't work with swap enabled (2/2)
  replace:
    path: /etc/fstab
    regexp: '^([^#].*?\sswap\s+sw\s+.*)$'
    replace: '# \1'
    
- name: Ensure Docker is running
  systemd:
    name: docker
    state: started
    enabled: yes

- name: Ensure Kubelet is running
  systemd:
    name: kubelet
    state: started
    enabled: yes